#include <errno.h>
#include <sys/wait.h>
#include <libgen.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <sys/ipc.h>                    //Shared memory
#include <sys/shm.h>                    //Shared memory
#include <signal.h>
#include <sys/time.h>
#include <sys/signal.h>
#include <unistd.h>
#include <stdlib.h>
#include <sqlite3.h>

#include <unistd.h>

#include<sys/socket.h>
#include<arpa/inet.h>



#define BAUDRATE B2400   // Change as needed, keep B

/* change this definition for the correct port */
#define MODEMDEVICE 	"/dev/ttyS3"

#define _POSIX_SOURCE 				1 		/* POSIX compliant source */
		
#define FALSE 						0
#define TRUE 						1
#define MAXSIZE						255
#define CS							13
#define USEC            			10000           //10ms
#define SEC							1		//for 1 second
#define READDATABASESEQ 			120		//if timer uses SEC define, 120 * 1s = 120 second
#define COMSTATUSTIMEOUTSN			15

#define TIMEOUTSEC					3
#define TIMEOUTSEC_COMMAND			2

#define SHAREDMEM_ADDR  			0x1000
#define SHAREDMEM_SIZE  			400

#define PARAMETERS_MAX  			7
#define ERR_COUNT					3
#define CONTROL_PARAMETERS_MAX		12

#define SAS_REQ         			0
#define OPL_REQ         			1
#define SRV_REQ         			2
#define SST_REQ         			3
#define FIR_REQ         			4
#define CLK_REQ         			5
#define DAT_REQ         			6
		
#define COM_NEVERCONNECTED			1
#define COM_ESTABLISHED				2
#define COM_LOST					3

//Shared Memory Addresses -> StsBuffer[]
/****************  home/pi/uart_sts.c (STS Communication) -> Agent.c  *******************/
#define SAS_1           			0
#define SAS_2           			1
#define SAS_3           			2
#define SAS_4           			3
#define SAS_5           			4
#define SAS_6           			5
#define OPL_1           			6
#define OPL_2           			7
#define OPL_3           			8
#define OPL_4           			9
#define OPL_5           			10
#define OPL_6           			11
#define OPL_7           			12
#define OPL_8           			13
#define SRV_1           			14
#define SRV_2           			15
#define SRV_3           			16
#define SRV_4           			17
#define SRV_5           			18
#define SRV_6           			19
#define SRV_7           			20
#define SRV_8           			21
#define SST_1           			22
#define SST_2           			23
#define SST_3           			24
#define SST_4           			25
#define SST_5           			26
#define SST_6           			27
#define SST_7           			28
#define CLK_1           			29
#define CLK_2           			30
#define DAT_1           			31
#define DAT_2           			32
#define DAT_3           			33
#define FIR_1           			34
#define FIR_2           			35
#define FIR_3           			36
#define FIR_4           			37
#define FIR_5           			38
#define FIR_6           			39
#define FIR_7           			40
#define FIR_8           			41
#define SAS_1_0         			42
#define SAS_1_1         			43
#define SAS_1_2         			44
#define SAS_1_3         			45
#define SAS_1_4         			46
#define SAS_1_5         			47
#define SAS_1_6         			48
#define SAS_1_7         			49
#define SAS_2_0         			50
#define SAS_2_1         			51
#define SAS_2_2         			52
#define SAS_2_3         			53
#define SAS_2_4         			54
#define SAS_2_5         			55
#define SAS_2_6         			56
#define SAS_2_7         			57
#define SAS_3_0         			58
#define SAS_3_1         			59
#define SAS_3_2         			60
#define SAS_3_3         			61
#define SAS_3_4         			62
#define SAS_3_5         			63
#define SAS_3_6         			64
#define SAS_3_7         			65
#define SAS_4_0         			66
#define SAS_4_1         			67
#define SAS_4_2         			68
#define SAS_4_3         			69
#define SAS_4_4         			70
#define SAS_4_5         			71
#define SAS_4_6         			72
#define SAS_4_7         			73
#define SAS_5_0         			74
#define SAS_5_1         			75
#define SAS_5_2         			76
#define SAS_5_3         			77
#define SAS_5_4         			78
#define SAS_5_5         			79
#define SAS_5_6         			80
#define SAS_5_7         			81

/****************  home/pi/uart_sts.c (sqlite3) -> Agent.c  *******************/
#define DUMMY1						82
#define NOMINALVOLT     			83
#define NOMINALFREQ     			84
#define NOMINALCURR     			85
#define PHASECOUNT      			86
#define POLECOUNT       			87
#define COMSTATUS       			88
#define OUTVOLTAGE      			89
#define OUTFREQ         			90
#define MODELNAME_1					91
#define MODELNAME_2					92
#define MODELNAME_3					93
#define MODELNAME_4					94
#define MODELNAME_5					95
#define MODELNAME_6					96
#define MODELNAME_7					97
#define MODELNAME_8					98
#define MODELNAME_9					99
#define MODELNAME_10				100
#define MODELNAME_11				101
#define MODELNAME_12				102
#define MODELNAME_13				103
#define MODELNAME_14				104
#define MODELNAME_15				105
#define MODELNAME_16				106
/****************  /usr/share/snmp/STS/Agent.c -> uart_sts.c (STS Communication)  *******************/
#define CONTROLRESETSTS         	107			//none(1)  reset(2)       (RESET-> EKLENECEK)
#define CONTROLCLEARALARMS      	108			//none(1)  clear(2)       (CLRALR->EKLENECEK)
#define CONTROLLOGIN            	109			//login(sifre) logout(2)  (PXXXX - OUT)
#define CONTROLSHUTDOWN         	110			//shutdown(1)             (INH)
#define CONTROLRESETSHUTDOWN    	111			//resetshutdown(1)        (IHR)
#define CONTROLMANUALXFER       	112			//Source1(1) Source2(2)   (XF1 - XF2)
#define CONTROLCANCELMANUALXFER 	113			//Always(1)               (CXF)
#define CONTROLPERFORMXFERTEST  	114			//Always(1)               (TST)
#define CONTROLSQLUPDATEFROMWEBSERVER 115
/* BOSLUK VAR, CONTROL ICIN BIRAKILDI, KULLANILABILIR */

#define EXFIR_9						130
#define EXFIR_10					131
#define EXFIR_11					132
#define EXFIR_12					133
#define EXFIR_13					134
#define EXFIR_14					135
#define EXFIR_15					136
#define EXFIR_16					137


#define SHAREDMEM_START_ADDR    	0
#define SHAREDMEM_ADDR_COUNT    	137

#define CONTROLSTARTADDR			107
#define CONTROLSTOPADDR				115
#define CONTROLADDRCOUNT			(CONTROLSTOPADDR-CONTROLSTARTADDR+1)

unsigned short StsBuffer[SHAREDMEM_ADDR_COUNT+1];






const unsigned char *Parameters[PARAMETERS_MAX] 	   	= { "SAS\r","OPL\r","SRV\r","SST\r","FIR\r","CLK\r","DAT\r"};
unsigned short ParametersDataCount[PARAMETERS_MAX] 		= {   46   ,  33   ,   35  ,   29  ,   99  ,   7   ,   8   };
unsigned short ParametersErrCounter[PARAMETERS_MAX];
unsigned short ParCntr = 0;


//uart define for CONTROL
#define UARTBUFF_CONTOLRESETSTS             	0
#define UARTBUFF_CONTROLCLEARALARMS         	1
#define UARTBUFF_CONTROLLOGIN               	2
#define UARTBUFF_CONTROLLOGOUT					3
#define UARTBUFF_CONTROLSHUTDOWN            	4
#define UARTBUFF_CONTROLRESETSHUTDOWN       	5
#define UARTBUFF_TRANSFER_SOURCE_1				6
#define UARTBUFF_TRANSFER_SOURCE_2              7
#define UARTBUFF_CONTROLCANCELMANUALXFER    	8
#define UARTBUFF_CONTROLPERFORMXFERTEST     	9
#define UARTBUFF_SOUND_ON						10
#define UARTBUFF_SOUND_OFF                      11

#define UART_RESET_COMMAND						2
#define UART_CLRALR_COMMAND						2
#define UART_LOGOUT_COMMAND						2
#define UART_SHUTDOWN_COMMAND					1
#define UART_RESETSHUTDOWN_COMMAND				1
#define UART_TRANSFER_SOURCE_1_COMMAND			1
#define UART_TRANSFER_SOURCE_2_COMMAND			2
#define UART_TRANSFER_CANCEL_COMMAND			1
#define UART_PERFORM_XFER_TEST_COMMAND			1
#define SQLITE_UPDATE_FROM_WEBSERVER        	5
//sound on - off komutlari Agent icin aktif degil

#define UART_CNTRL_AND_PERIODIC_READY			0
#define UART_CNTRL_WILL_SEND					1

#define COMMAND_SEND_COUNTER					2


#define ETHERNET_CONNECTED    					1
#define ETHERNET_DISCONNECTED  					0
#define ETHERNET_ERROR 	      					2
#define ETHERNET_FLAG_COUNTER 					5
#define ALLOWED               					1
#define NOTALLOWED            					0


unsigned short SqliteUpdateFromWebServerFLAG = 0;

const unsigned char *ControlParameters[CONTROL_PARAMETERS_MAX] = { "RESET\r","CLRALR\r","P####\r","OUT\r",
								   "INH\r"  ,"IHR\r"   ,"XF1\r"  ,"XF2\r",
								   "CXF\r"  ,"TST\r"   ,"SON\r"  ,"SOF\r"   };
unsigned short CntrlParNo   = 0;
unsigned short CntrlFLAG    = 0;
unsigned short CntrlCounter = 0;
unsigned short LoginPassword = 0;
unsigned char PasswBuffer[6];

unsigned short *DynamicAddr;
int ShmID;
unsigned short Rcved = 0;
unsigned short NextSend = 0;
unsigned short Query = 0;
unsigned short TimeoutCntr = 0;
unsigned short ReadDataBaseCounter = 0;
unsigned short ComStatusBackCounter = 0;

struct Alarm
{
	unsigned bit7	:1;
	unsigned bit6	:1;
	unsigned bit5	:1;
	unsigned bit4	:1;
	unsigned bit3	:1;
	unsigned bit2	:1;
	unsigned bit1	:1;
	unsigned bit0	:1;
};

union AlarmUnion
{
	unsigned char all;
	struct Alarm alarmstruct;
};



union AlarmUnion alarm1;
union AlarmUnion alarm2;
union AlarmUnion alarm3;
union AlarmUnion alarm4;
union AlarmUnion alarm5;


unsigned short UartRequestPermissionFromEthernet = ALLOWED;
unsigned short EthernetStatusCounter = ETHERNET_FLAG_COUNTER;

//SIG INT variables
struct sigaction old_action;

void VariableClear(unsigned short query);
void TransferVariableAndDynamic(void);
void ControlFunction(void);



int sock;


void sigint_handler(int sig_no) /* signal handler function */
{
	printf("signalNo : %d\n",sig_no);
    	printf("Cntl-C pressed\n");

	shmdt(DynamicAddr);
	shmctl(ShmID, IPC_RMID, NULL);
	close(sock);

    	sigaction(SIGINT,&old_action,NULL);
    	kill(0,SIGINT);
    	exit(0);
}

void event_handler (int signum)
{
	static unsigned short counter = 0;

	printf("signum : %d\n",signum);

	if( TimeoutCntr > 0 )
		TimeoutCntr--;

	if( ReadDataBaseCounter > 0 )
		ReadDataBaseCounter--;

	if( ComStatusBackCounter > 0 )
		ComStatusBackCounter--;

	if( EthernetStatusCounter > 0 )
		EthernetStatusCounter--;


//	if( ++counter > 99 )
//	{
		counter = 0;
		//printf("timer\n",signum);
		NextSend = 1;
//	}
}

void signal_handler_IO (int status)
{
	printf("status : %d\n",status);
	//printf("uart\n");
	Rcved = 1;
}

void active_shared(void)
{

    //Shared Memory i acar.
    if ((ShmID = shmget(SHAREDMEM_ADDR,SHAREDMEM_SIZE,IPC_CREAT|0666)) < 0)
    {
            perror("shmget");
    }
    if ((DynamicAddr = (unsigned short *)shmat(ShmID, NULL, 0)) == (void *) -1)
    {
            perror("shmat");
    }
}
void ClearBuffer(unsigned char *Str,unsigned char BufferCount)
{
	unsigned int xx = 0;

	for(xx=0;xx<BufferCount;xx++)
		*(Str+xx) = 0;
}

unsigned short Variable(unsigned short buffer1,unsigned short buffer2,unsigned short buffer3)
{
	unsigned short var = 0;

	var = (buffer1-48) * 100 + (buffer2-48) * 10 + (buffer3-48);

	return var;
}

const unsigned char *name[6] = {
	"ModelName",
	"NominalVolt",
	"NominalFreq",
	"NominalCurr",
	"Phase",
	"Pole"
};

static int callback(void *data, int argc, char **argv, char **azColName)
{
	int i = 0;
	int z = 0;

        for( i = 0; i < argc; i++ )
        {
		if( strstr( azColName[i],name[i]) == NULL )			//database.db okunamazsa ya da yoksa
		{
			if( strstr( azColName[i],name[0]) != NULL)
			{
                                StsBuffer[MODELNAME_1] = 0x20;        //space character
                                StsBuffer[MODELNAME_2] = 0x20;
                                StsBuffer[MODELNAME_3] = 0x20;
                                StsBuffer[MODELNAME_4] = 0x20;
                                StsBuffer[MODELNAME_5] = 0x20;
                                StsBuffer[MODELNAME_6] = 0x20;
                                StsBuffer[MODELNAME_7] = 0x20;
                                StsBuffer[MODELNAME_8] = 0x20;
                                StsBuffer[MODELNAME_9] = 0x20;
                                StsBuffer[MODELNAME_10] = 0x20;
                                StsBuffer[MODELNAME_11] = 0x20;
                                StsBuffer[MODELNAME_12] = 0x20;
                                StsBuffer[MODELNAME_13] = 0x20;
                                StsBuffer[MODELNAME_14] = 0x20;
                                StsBuffer[MODELNAME_15] = 0x20;
                                StsBuffer[MODELNAME_16] = 0x20;
			}
			else if( strstr( azColName[i],name[1]) != NULL)
			{
				StsBuffer[NOMINALVOLT] = 0;
			}
                        else if( strstr( azColName[i],name[2]) != NULL)
                        {
                                StsBuffer[NOMINALFREQ] = 0;
                        }
                        else if( strstr( azColName[i],name[3]) != NULL)
                        {
                                StsBuffer[NOMINALCURR] = 0;
                        }
                        else if( strstr( azColName[i],name[4]) != NULL)
                        {
                                StsBuffer[PHASECOUNT] = 0;
                        }
                        else if( strstr( azColName[i],name[5]) != NULL)
                        {
                                StsBuffer[POLECOUNT] = 0;
                        }

		}
		else								//database.sb okunursa
		{
                        if( strstr( azColName[i],name[0]) != NULL)
                        {
                                StsBuffer[MODELNAME_1] = 0x20;        //space character
                                StsBuffer[MODELNAME_2] = 0x20;
                                StsBuffer[MODELNAME_3] = 0x20;
                                StsBuffer[MODELNAME_4] = 0x20;
                                StsBuffer[MODELNAME_5] = 0x20;
                                StsBuffer[MODELNAME_6] = 0x20;
                                StsBuffer[MODELNAME_7] = 0x20;
                                StsBuffer[MODELNAME_8] = 0x20;
                                StsBuffer[MODELNAME_9] = 0x20;
                                StsBuffer[MODELNAME_10] = 0x20;
                                StsBuffer[MODELNAME_11] = 0x20;
                                StsBuffer[MODELNAME_12] = 0x20;
                                StsBuffer[MODELNAME_13] = 0x20;
                                StsBuffer[MODELNAME_14] = 0x20;
                                StsBuffer[MODELNAME_15] = 0x20;
                                StsBuffer[MODELNAME_16] = 0x20;

				for( z = 0; z < 16; z++ )
				{
					if( *(argv[i]+z) != '\n' )
                                		StsBuffer[MODELNAME_1+z] = *(argv[i]+z);
					else
						StsBuffer[MODELNAME_1+z] = 0x20;
				}
//				printf("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",StsBuffer[MODELNAME_1],StsBuffer[MODELNAME_2],StsBuffer[MODELNAME_3],
//							    StsBuffer[MODELNAME_4],StsBuffer[MODELNAME_5],StsBuffer[MODELNAME_6],
//							    StsBuffer[MODELNAME_7],StsBuffer[MODELNAME_8],StsBuffer[MODELNAME_9],StsBuffer[MODELNAME_10],
//							    StsBuffer[MODELNAME_11],StsBuffer[MODELNAME_12],StsBuffer[MODELNAME_13],StsBuffer[MODELNAME_14],
//							    StsBuffer[MODELNAME_15],StsBuffer[MODELNAME_16]);

                        }
                        else if( strstr( azColName[i],name[1]) != NULL)
                        {
                                StsBuffer[NOMINALVOLT] = atoi(argv[i]);
                        }
                        else if( strstr( azColName[i],name[2]) != NULL)
                        {
                                StsBuffer[NOMINALFREQ] = atoi(argv[i]);
                        }
                        else if( strstr( azColName[i],name[3]) != NULL)
                        {
                                StsBuffer[NOMINALCURR] = atoi(argv[i]);
                        }
                        else if( strstr( azColName[i],name[4]) != NULL)
                        {
                                StsBuffer[PHASECOUNT] = atoi(argv[i]);
                        }
                        else if( strstr( azColName[i],name[5]) != NULL)
                        {
                                StsBuffer[POLECOUNT] = atoi(argv[i]);
                        }
		}

        }



   return 0;
}

short ReadDatabase(void)
{
        //sqlite variables
        sqlite3 *db;
        char *zErrMsg = 0;
        int rc;
        char *sql;
	const char* data = "Callback function called";


	rc = sqlite3_open("/opt/SNMP/database.db", &db);

  	if( rc )
	{
//      		fprintf(stderr, "Can't open database: %s\n", sqlite3_errmsg(db));
//      		return(-1);
   	}
	else
	{
//      		fprintf(stderr, "Opened database successfully\n");

		/* Create SQL statement */
		sql = "SELECT * from KAYIT";
		rc = sqlite3_exec(db, sql, callback, (void*)data, &zErrMsg);

   		if( rc != SQLITE_OK )
		{
  //    			fprintf(stderr, "SQL error: %s\n", zErrMsg);
      			sqlite3_free(zErrMsg);
   		}
		else
		{
    //  			fprintf(stdout, "Operation done successfully\n");
   		}
   		sqlite3_close(db);
   		return 0;
   	}

}
void get_popen_1()
{
    FILE *pf;
    char command[200];
    char data[512];

    // Execute a process listing
    sprintf(command, "snmptrap -v 1 -c public 10.0.0.105 .1.3.6.1.4.1.54358.1.1.4.4.2.1.0 \"\" 0 0 coldStart.0"); 

    // Setup our pipe for reading and execute our command.
    pf = popen(command,"r"); 

    // Error handling

    // Get the data from the process execution
    fgets(data, 512 , pf);

    // the data is now in 'data'

    if (pclose(pf) != 0)
        fprintf(stderr," Error: Failed to close command stream \n");

//    return;
}

short get_popen()
{
    FILE *pf;
    char command[200];
    char data[512];

    // Execute a process listing
//    sprintf(command, "nmcli device status | grep ethernet | awk '{print $3}'");
    sprintf(command,"mii-tool eth0");
    // Setup our pipe for reading and execute our command.
    pf = popen(command,"r");

    // Error handling

    // Get the data from the process execution
    fgets(data, 512 , pf);

    // the data is now in 'data'

    if (pclose(pf) != 0)
    {
 	//fprintf(stderr," Error: Failed to close command stream \n");
	return ETHERNET_ERROR;
    }
    else
    {
	//printf("data: %s\n",data);

	if( strstr( data, "no link") != NULL )
		return ETHERNET_DISCONNECTED;
	else if( strstr( data, "link ok") != NULL )
		return ETHERNET_CONNECTED;
	else
		return ETHERNET_DISCONNECTED;
    }
}

short SocketCreate(void)
{
    short hSocket;
    printf("Create the socket\n");
    hSocket = socket(AF_INET, SOCK_STREAM, 0);
    return hSocket;
}
int BindCreatedSocket(int hSocket)
{
    int iRetval=-1;
    int ClientPort = 10007;
    struct sockaddr_in  remote= {0};
    /* Internet address family */
    remote.sin_family = AF_INET;
    /* Any incoming interface */
    remote.sin_addr.s_addr = htonl(INADDR_ANY);
    remote.sin_port = htons(ClientPort); /* Local port */
    iRetval = bind(hSocket,(struct sockaddr *)&remote,sizeof(remote));
    return iRetval;
}




int main(int argc, char *argv[])
{
	int fd,c;
	struct termios oldtio, newtio;
	unsigned char RcvBuff[MAXSIZE];
	unsigned char charRead;
	int RcvLength = 0;
	int loop = 0;
	short answer = 0;
	int counter = 0;
	unsigned short returnflag = 0;


	//tcp socket variables
	int socket_desc, clientLen, read_size;
	struct sockaddr_in server, client;
	char client_message[200]= {0};
	char message[100] = {0};


	//Timer variables
	struct sigaction sa;
	struct itimerval timer;

	//SIG INT variables
	struct sigaction action;
	memset(&action, 0, sizeof(action));
	action.sa_handler = &sigint_handler;
	sigaction(SIGINT, &action, &old_action);

	//Timer SetUp

	memset (&sa, 0, sizeof (sa));
	sa.sa_handler = &event_handler;
	sigaction (SIGALRM, &sa, NULL);
	timer.it_value.tv_sec = SEC;
	timer.it_value.tv_usec = 0;//USEC;
	timer.it_interval.tv_sec = SEC;
	timer.it_interval.tv_usec = 0;//USEC;
	setitimer (ITIMER_REAL, &timer, NULL);

	// Load the pin configuration
	//int ret = system("echo BB-UART4 > /sys/devices/bone_capemgr.9/slots");
	//int ret = system("echo BB-UART4 > /sys/devices/platform/bone_capemgr/slots");	

	/* Open modem device for reading and writing and not as controlling tty
	because we don't want to get killed if linenoise sends CTRL-C. */
	fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK );

	if (fd < 0) { perror(MODEMDEVICE); exit(-1); }
	bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */


	//Uart variables and setup
	struct sigaction saio;           /* definition of signal action */

	/* install the signal handler before making the device asynchronous */
	saio.sa_handler = signal_handler_IO;
	//saio.sa_mask = 0;
	saio.sa_flags = 0;
	saio.sa_restorer = NULL;
	sigaction(SIGPOLL,&saio,NULL);

	/* allow the process to receive SIGIO */
	fcntl(fd, F_SETOWN, getpid());
	/* Make the file descriptor asynchronous (the manual page says only
	O_APPEND and O_NONBLOCK, will work with F_SETFL...) */
	fcntl(fd, F_SETFL, FASYNC);

	tcgetattr(fd,&oldtio); /* save current port settings */
	/* BAUDRATE: Set bps rate. You could also use cfsetispeed and cfsetospeed.
	CRTSCTS : output hardware flow control (only used if the cable has
			 all necessary lines. See sect. 7 of Serial-HOWTO)
	CS8     : 8n1 (8bit,no parity,1 stopbit)
	CLOCAL  : local connection, no modem contol
	CREAD   : enable receiving characters */
	newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;

	/* IGNPAR  : ignore bytes with parity errors
	otherwise make device raw (no other input processing)
	ICRNL   : map CR to NL (otherwise a CR input on the other computer
	will not terminate input)*/
	newtio.c_iflag = IGNPAR | ICRNL;

	/*  Raw output  */
	newtio.c_oflag = 0;

	/* ICANON  : enable canonical input
	disable all echo functionality, and don't send signals to calling program */
	newtio.c_lflag = ICANON;

	newtio.c_cc[VMIN]=1;
	newtio.c_cc[VTIME]=0;

	/* now clean the modem line and activate the settings for the port */
	tcflush(fd, TCIFLUSH);
	tcsetattr(fd,TCSANOW,&newtio);

	active_shared();

	ReadDatabase();	//belki belli araliklarda sorgulanir.
	ReadDataBaseCounter = READDATABASESEQ;

	StsBuffer[COMSTATUS] = COM_NEVERCONNECTED;


    //Create socket
    socket_desc = SocketCreate();
    if (socket_desc == -1)
    {
        printf("Could not create socket");
        return 1;
    }
    printf("Socket created\n");
    //Bind
    if( BindCreatedSocket(socket_desc) < 0)
    {
        //print the error message
        perror("bind failed.");
        return 1;
    }
    printf("bind done\n");
    //Listen
    listen(socket_desc, 3);



	while(1)
	{

        printf("Waiting for incoming connections...\n");
        clientLen = sizeof(struct sockaddr_in);
        //accept connection from an incoming client
        sock = accept(socket_desc,(struct sockaddr *)&client,(socklen_t*)&clientLen);
        if (sock < 0)
        {
            perror("accept failed");
            return 1;
        }
        printf("Connection accepted\n");
        memset(client_message, '\0', sizeof client_message);
        memset(message, '\0', sizeof message);
        //Receive a reply from the client
        if( recv(sock, client_message, 200, 0) < 0)
        {
            printf("recv failed");
            break;
        }
        printf("Client reply : %s\n",client_message);
//        close(sock);
//        sleep(1);


		if( NextSend == 2 )
			sleep(2);
		//if( ReadDataBaseCounter == 0 )
		if( (SqliteUpdateFromWebServerFLAG == 1) || (ReadDataBaseCounter == 0) )
		{
			SqliteUpdateFromWebServerFLAG = 0;
			ReadDatabase();
			ReadDataBaseCounter = READDATABASESEQ;
		}
		if( EthernetStatusCounter == 0 )
		{
			answer = get_popen();
			//printf("answer = %d",answer);
			if( answer == ETHERNET_CONNECTED )
				UartRequestPermissionFromEthernet = ALLOWED;
			else if( answer == ETHERNET_DISCONNECTED )
				UartRequestPermissionFromEthernet = NOTALLOWED;
			EthernetStatusCounter = ETHERNET_FLAG_COUNTER;
		}
		if( (ComStatusBackCounter == 0) && (StsBuffer[COMSTATUS] == COM_ESTABLISHED) )
		{
			StsBuffer[COMSTATUS] = COM_LOST;
		}
		switch( Query )
		{
			case 0:
			    if( (NextSend == 1) && (UartRequestPermissionFromEthernet == ALLOWED) )			//her saniye 1 olur. (source:timer interrupt)
				{
					if(returnflag == 1 )
					{
						sleep(1);

        memset(&action, 0, sizeof(action));
        action.sa_handler = &sigint_handler;
        sigaction(SIGINT, &action, &old_action);

        //Timer SetUp
        memset (&sa, 0, sizeof (sa));
        sa.sa_handler = &event_handler;
        sigaction (SIGALRM, &sa, NULL);
        timer.it_value.tv_sec = SEC;
        timer.it_value.tv_usec = 0;//USEC;
        timer.it_interval.tv_sec = SEC;
        timer.it_interval.tv_usec = 0;//USEC;
        setitimer (ITIMER_REAL, &timer, NULL);

        // Load the pin configuration
        //int ret = system("echo BB-UART4 > /sys/devices/bone_capemgr.9/slots");
        //int ret = system("echo BB-UART4 > /sys/devices/platform/bone_capemgr/slots");

        /* Open modem device for reading and writing and not as controlling tty
        because we don't want to get killed if linenoise sends CTRL-C. */
        fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK );


        if (fd < 0) { perror(MODEMDEVICE); exit(-1); }
        bzero(&newtio, sizeof(newtio)); /* clear struct for new port settings */


        //Uart variables and setup

        /* install the signal handler before making the device asynchronous */
        saio.sa_handler = signal_handler_IO;
        //saio.sa_mask = 0;
        saio.sa_flags = 0;
        saio.sa_restorer = NULL;
        sigaction(SIGPOLL,&saio,NULL);

        /* allow the process to receive SIGIO */
        fcntl(fd, F_SETOWN, getpid());
        /* Make the file descriptor asynchronous (the manual page says only
        O_APPEND and O_NONBLOCK, will work with F_SETFL...) */
        fcntl(fd, F_SETFL, FASYNC);

        tcgetattr(fd,&oldtio); /* save current port settings */
        /* BAUDRATE: Set bps rate. You could also use cfsetispeed and cfsetospeed.
        CRTSCTS : output hardware flow control (only used if the cable has
                         all necessary lines. See sect. 7 of Serial-HOWTO)
        CS8     : 8n1 (8bit,no parity,1 stopbit)
        CLOCAL  : local connection, no modem contol
        CREAD   : enable receiving characters */
        newtio.c_cflag = BAUDRATE | CRTSCTS | CS8 | CLOCAL | CREAD;

        /* IGNPAR  : ignore bytes with parity errors
        otherwise make device raw (no other input processing)
        ICRNL   : map CR to NL (otherwise a CR input on the other computer
        will not terminate input)*/
        newtio.c_iflag = IGNPAR | ICRNL;

        /*  Raw output  */
        newtio.c_oflag = 0;

        /* ICANON  : enable canonical input
        disable all echo functionality, and don't send signals to calling program */
        newtio.c_lflag = ICANON;

        newtio.c_cc[VMIN]=1;
        newtio.c_cc[VTIME]=0;

        /* now clean the modem line and activate the settings for the port */
        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&newtio);

        active_shared();

        ReadDatabase(); //belki belli araliklarda sorgulanir.
        ReadDataBaseCounter = READDATABASESEQ;

        StsBuffer[COMSTATUS] = COM_NEVERCONNECTED;

						returnflag = 0;
						sleep(1);
					}
					NextSend = 2;

					if( CntrlFLAG == UART_CNTRL_WILL_SEND )
					{
						if( CntrlParNo == UARTBUFF_CONTROLLOGIN )
						{
							PasswBuffer[0] = 'P';
							PasswBuffer[1] = (LoginPassword / 1000)+48;
							PasswBuffer[2] = ((LoginPassword % 1000) / 100)+48;
							PasswBuffer[3] = ((LoginPassword % 100) / 10)+48;
							PasswBuffer[4] = ((LoginPassword % 10)+48);
							PasswBuffer[5] = 13;

							write(fd,PasswBuffer,strlen(PasswBuffer));
						}
						else
						{
							write(fd,ControlParameters[CntrlParNo],strlen(ControlParameters[CntrlParNo]));
						}
						TimeoutCntr = TIMEOUTSEC_COMMAND;
						Query = 99;
					}
					else
					{
						write(fd,Parameters[ParCntr],strlen(Parameters[ParCntr]));
						//printf("%s\n",Parameters[ParCntr]);

						TimeoutCntr = TIMEOUTSEC;
						Query = 1;
					}
				}
else
{
	returnflag = 1;
	sleep(1);
//	printf("not allowed\n");
                                        if(Rcved == 1)
                                        {
	Rcved = 0;
//	printf("data geldi\n");
	RcvLength = read(fd,RcvBuff,MAXSIZE);
}
//	sleep(10);
}
			break;
			case 99://komut gonderildikten sonra cevap geliyorsa Periyodik sormalara devam eder.
					//Timeout a dusuyorsa COMMAND_SEND_COUNTER kadar tekrar gonderir ve sonra Periyodik sormalara devam eder.
					if(Rcved == 1)
					{
						Rcved = 0;
						RcvLength = read(fd,RcvBuff,MAXSIZE);

						RcvBuff[RcvLength] = 0;
						RcvLength--;

						ClearBuffer(RcvBuff,RcvLength);

						CntrlFLAG = UART_CNTRL_AND_PERIODIC_READY;
						Query = 0;
					}
					else if( TimeoutCntr == 0 )
					{
						if( ++CntrlCounter < COMMAND_SEND_COUNTER )
						{
							CntrlFLAG = UART_CNTRL_WILL_SEND;
							Query = 0;
						}
						else
						{
							CntrlCounter = 0;
							CntrlFLAG = UART_CNTRL_AND_PERIODIC_READY;
							Query = 0;
						}
                    }
			break;
			case 1:
					if(Rcved == 1)
					{
						//StsBuffer[CONTROLRESETSTS] = *(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLRESETSTS);
						//printf("value of the:%d\n",StsBuffer[CONTROLRESETSTS]);	//contol variable lari gormek icin OK
						Rcved = 0;
						RcvLength = read(fd,RcvBuff,MAXSIZE);
	//		printf("%d\n%s\n",RcvLength,RcvBuff);

						RcvBuff[RcvLength] = 0;
						RcvLength--;

					if( ((RcvLength+1) == ParametersDataCount[ParCntr]) || (ParametersDataCount[ParCntr] == 99) )	//99 -> FIR cevabi icin esnek davranildi.
					{
						switch(ParCntr)
						{
							case SAS_REQ:
								if( (RcvBuff[0] != '#') || (RcvBuff[9] != ' ') || (RcvBuff[18] != ' ') || (RcvBuff[27] != ' ') || (RcvBuff[36] != ' ') )
								{
									Query = 4;
									break;
								}
								//Alarmlar icin sacma degerler gelirse duzeltmeye yariyor. (RcvBuff[38] <- 6 geldigi icin yaptim.
							//	for (counter = 1; counter < 45;counter++)
							//	{
							//		if( RcvBuff[counter] > 49 )
							//			RcvBuff[counter] = 49;
							//	}

								StsBuffer[COMSTATUS] = COM_ESTABLISHED;
								ComStatusBackCounter = COMSTATUSTIMEOUTSN;
								//printf("OK_SAS\n");

								ParametersErrCounter[SAS_REQ] = 0;
								StsBuffer[SAS_1] = ((RcvBuff[1] -48)*128) + ((RcvBuff[2] -48)*64) + ((RcvBuff[3] -48)*32) + ((RcvBuff[4] -48)*16) + ((RcvBuff[5] -48)*8) + ((RcvBuff[6] -48)*4) + ((RcvBuff[7] -48)*2) + ((RcvBuff[8]-48) );
								StsBuffer[SAS_2] = ((RcvBuff[10]-48)*128) + ((RcvBuff[11]-48)*64) + ((RcvBuff[12]-48)*32) + ((RcvBuff[13]-48)*16) + ((RcvBuff[14]-48)*8) + ((RcvBuff[15]-48)*4) + ((RcvBuff[16]-48)*2) + ((RcvBuff[17]-48));
								StsBuffer[SAS_3] = ((RcvBuff[19]-48)*128) + ((RcvBuff[20]-48)*64) + ((RcvBuff[21]-48)*32) + ((RcvBuff[22]-48)*16) + ((RcvBuff[23]-48)*8) + ((RcvBuff[24]-48)*4) + ((RcvBuff[25]-48)*2) + ((RcvBuff[26]-48));
								StsBuffer[SAS_4] = ((RcvBuff[28]-48)*128) + ((RcvBuff[29]-48)*64) + ((RcvBuff[30]-48)*32) + ((RcvBuff[31]-48)*16) + ((RcvBuff[32]-48)*8) + ((RcvBuff[33]-48)*4) + ((RcvBuff[34]-48)*2) + ((RcvBuff[35]-48));
								//StsBuffer[SAS_5] = ((RcvBuff[37]-48)*128) + ((RcvBuff[38]-48)*64) + ((RcvBuff[39]-48)*32) + ((RcvBuff[40]-48)*16) + ((RcvBuff[41]-48)*8) + ((RcvBuff[42]-48)*4) + ((RcvBuff[43]-48)*2) + ((RcvBuff[44]-48));

								alarm1.all = StsBuffer[SAS_1];
								alarm2.all = StsBuffer[SAS_2];
								alarm3.all = StsBuffer[SAS_3];
								alarm4.all = StsBuffer[SAS_4];
								//alarm5.all = StsBuffer[SAS_5];

								StsBuffer[SAS_1_0] = alarm1.alarmstruct.bit0;
								StsBuffer[SAS_1_1] = alarm1.alarmstruct.bit1;
								StsBuffer[SAS_1_2] = alarm1.alarmstruct.bit2;
								StsBuffer[SAS_1_3] = alarm1.alarmstruct.bit3;
								StsBuffer[SAS_1_4] = alarm1.alarmstruct.bit4;
                                                                StsBuffer[SAS_1_5] = alarm1.alarmstruct.bit5;
                                                                StsBuffer[SAS_1_6] = alarm1.alarmstruct.bit6;
                                                                StsBuffer[SAS_1_7] = alarm1.alarmstruct.bit7;

                                                                StsBuffer[SAS_2_0] = alarm2.alarmstruct.bit0;
                                                                StsBuffer[SAS_2_1] = alarm2.alarmstruct.bit1;
                                                                StsBuffer[SAS_2_2] = alarm2.alarmstruct.bit2;
                                                                StsBuffer[SAS_2_3] = alarm2.alarmstruct.bit3;
                                                                StsBuffer[SAS_2_4] = alarm2.alarmstruct.bit4;
                                                                StsBuffer[SAS_2_5] = alarm2.alarmstruct.bit5;
                                                                StsBuffer[SAS_2_6] = alarm2.alarmstruct.bit6;
                                                                StsBuffer[SAS_2_7] = alarm2.alarmstruct.bit7;

                                                                StsBuffer[SAS_3_0] = alarm3.alarmstruct.bit0;
                                                                StsBuffer[SAS_3_1] = alarm3.alarmstruct.bit1;
                                                                StsBuffer[SAS_3_2] = alarm3.alarmstruct.bit2;
                                                                StsBuffer[SAS_3_3] = alarm3.alarmstruct.bit3;
                                                                StsBuffer[SAS_3_4] = alarm3.alarmstruct.bit4;
                                                                StsBuffer[SAS_3_5] = alarm3.alarmstruct.bit5;
                                                                StsBuffer[SAS_3_6] = alarm3.alarmstruct.bit6;
                                                                StsBuffer[SAS_3_7] = alarm3.alarmstruct.bit7;

                                                                StsBuffer[SAS_4_0] = alarm4.alarmstruct.bit0;
                                                                StsBuffer[SAS_4_1] = alarm4.alarmstruct.bit1;
                                                                StsBuffer[SAS_4_2] = alarm4.alarmstruct.bit2;
                                                                StsBuffer[SAS_4_3] = alarm4.alarmstruct.bit3;
                                                                StsBuffer[SAS_4_4] = alarm4.alarmstruct.bit4;
                                                                StsBuffer[SAS_4_5] = alarm4.alarmstruct.bit5;
                                                                StsBuffer[SAS_4_6] = alarm4.alarmstruct.bit6;
                                                                StsBuffer[SAS_4_7] = alarm4.alarmstruct.bit7;
unsigned short aaa = 0;

                                                                StsBuffer[SAS_5_0] = (unsigned short)(RcvBuff[37]-48);//alarm5.alarmstruct.bit0;
                                                                StsBuffer[SAS_5_1] = (unsigned short)(RcvBuff[38]-48);//alarm5.alarmstruct.bit1;
								if( (RcvBuff[38]-48) == 2 )
									StsBuffer[SAS_5_1] = 0;
								else if( (RcvBuff[38]-48) == 3 )
                                                                        StsBuffer[SAS_5_1] = 1;
                                                                else if( (RcvBuff[38]-48) == 0 )
								{
									if( (RcvBuff[37]-48) == 0 )
                                                                        	StsBuffer[SAS_5_1] = 0;
                                                                        if( (RcvBuff[37]-48) == 1 )
                                                                                StsBuffer[SAS_5_1] = 1;
								}
								else if( (RcvBuff[38]-48) == 1 )
								{
                                                                        if( (RcvBuff[37]-48) == 0 )
                                                                                StsBuffer[SAS_5_1] = 1;
                                                                        if( (RcvBuff[37]-48) == 1 )
                                                                                StsBuffer[SAS_5_1] = 0;
								}
								else
									StsBuffer[SAS_5_1] = 0;
							//	aaa = StsBuffer[SAS_5_1];
							//	printf("sas5-1  :%d\n",aaa);

                                                                StsBuffer[SAS_5_2] = (unsigned short)(RcvBuff[39]-48);//alarm5.alarmstruct.bit2;
                                                                StsBuffer[SAS_5_3] = (unsigned short)(RcvBuff[40]-48);//alarm5.alarmstruct.bit3;
                                                                StsBuffer[SAS_5_4] = (unsigned short)(RcvBuff[41]-48);//alarm5.alarmstruct.bit4;
                                                                StsBuffer[SAS_5_5] = (unsigned short)(RcvBuff[42]-48);//alarm5.alarmstruct.bit5;
                                                                StsBuffer[SAS_5_6] = (unsigned short)(RcvBuff[43]-48);//alarm5.alarmstruct.bit6;
                                                                StsBuffer[SAS_5_7] = (unsigned short)(RcvBuff[44]-48);//alarm5.alarmstruct.bit7;


								Query = 2;
							break;

							case OPL_REQ:
                                                                if( (RcvBuff[0] != '#') || (RcvBuff[4] != ' ') || (RcvBuff[8] != ' ') || (RcvBuff[12] != ' ') || (RcvBuff[16] != ' ') || 
								    (RcvBuff[20] != ' ')|| (RcvBuff[24] != ' ')|| (RcvBuff[28] != ' ')  )
                                                                {
                                                                        Query = 4;
                                                                        break;
                                                                }

                                                                //printf("OK_OPL\n");
								StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

								ParametersErrCounter[OPL_REQ] = 0;
								StsBuffer[OPL_1] = Variable(RcvBuff[1],RcvBuff[2],RcvBuff[3]);
								StsBuffer[OPL_2] = Variable(RcvBuff[5],RcvBuff[6],RcvBuff[7]);
								StsBuffer[OPL_3] = Variable(RcvBuff[9],RcvBuff[10],RcvBuff[11]);
								StsBuffer[OPL_4] = Variable(RcvBuff[13],RcvBuff[14],RcvBuff[15]);
								StsBuffer[OPL_5] = Variable(RcvBuff[17],RcvBuff[18],RcvBuff[19]);
								StsBuffer[OPL_6] = Variable(RcvBuff[21],RcvBuff[22],RcvBuff[23]);
								StsBuffer[OPL_7] = Variable(RcvBuff[25],RcvBuff[26],RcvBuff[27]);
								StsBuffer[OPL_8] = Variable(RcvBuff[29],RcvBuff[30],RcvBuff[31]);

                                                                Query = 2;

							break;

							case SRV_REQ:
								if( (RcvBuff[0] != '#') || (RcvBuff[4] != ' ') || (RcvBuff[8] != ' ') || (RcvBuff[12] != ' ') || (RcvBuff[16] != ' ') || 
                                                                    (RcvBuff[20] != ' ')|| (RcvBuff[24] != ' ')|| (RcvBuff[29] != ' ')|| (RcvBuff[27] != '.')|| (RcvBuff[32] != '.')  )

                                                                {
                                                                        Query = 4;
                                                                        break;
                                                                }

                                                                //printf("OK_SRV\n");
                                                                StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

								ParametersErrCounter[SRV_REQ] = 0;
                                                                StsBuffer[SRV_1] = Variable(RcvBuff[1],RcvBuff[2],RcvBuff[3]);
                                                                StsBuffer[SRV_2] = Variable(RcvBuff[5],RcvBuff[6],RcvBuff[7]);
                                                                StsBuffer[SRV_3] = Variable(RcvBuff[9],RcvBuff[10],RcvBuff[11]);
                                                                StsBuffer[SRV_4] = Variable(RcvBuff[13],RcvBuff[14],RcvBuff[15]);
                                                                StsBuffer[SRV_5] = Variable(RcvBuff[17],RcvBuff[18],RcvBuff[19]);
                                                                StsBuffer[SRV_6] = Variable(RcvBuff[21],RcvBuff[22],RcvBuff[23]);
																if( (RcvBuff[25] >= '0') && (RcvBuff[25] <= '9') )
																	RcvBuff[25] = RcvBuff[25];
																else	
																	RcvBuff[25] = '0';
																
                                                                StsBuffer[SRV_7] = Variable(RcvBuff[25],RcvBuff[26],RcvBuff[28]);
                                                                StsBuffer[SRV_8] = Variable(RcvBuff[30],RcvBuff[31],RcvBuff[33]);


//  char *binaryPath = "/usr/bin/snmptrap";
//  char *args[] = {binaryPath, "-v", "1","-c","public","10.0.0.105",".1.3.6.1.4.1.54358.1.1.4.4.2.1.0","\"\"","0","0","coldStart.0", NULL};

//if( StsBuffer[SRV_1] > 230 )
//{
////        printf("send it\n %s,%s\n",binaryPath,args);
////  execv(binaryPath, args);
//system("snmptrap -v 1 -c public 10.0.0.105 .1.3.6.1.4.1.54358.1.1.4.4.2.1.0 \"\" 0 0 coldStart.0");
////get_popen();
//}



                                                                Query = 2;

        	                                        break;

                	                                case SST_REQ:
                                                                if( (RcvBuff[0] != '#') || (RcvBuff[4] != ' ') || (RcvBuff[8] != ' ') || (RcvBuff[12] != ' ') || (RcvBuff[16] != ' ') ||
								    (RcvBuff[20] != ' ')|| (RcvBuff[24] != ' ') )
                                                                {
                                                                        Query = 4;
                                                                        break;
                                                                }

                                                                //printf("OK_SST\n");
                                                                StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

								ParametersErrCounter[SST_REQ] = 0;
								StsBuffer[SST_1] = Variable(RcvBuff[1],RcvBuff[2],RcvBuff[3]);
                                                                StsBuffer[SST_2] = Variable(RcvBuff[5],RcvBuff[6],RcvBuff[7]);
                                                                StsBuffer[SST_3] = Variable(RcvBuff[9],RcvBuff[10],RcvBuff[11]);
                                                                StsBuffer[SST_4] = Variable(RcvBuff[13],RcvBuff[14],RcvBuff[15]);
                                                                StsBuffer[SST_5] = Variable(RcvBuff[17],RcvBuff[18],RcvBuff[19]);
                                                                StsBuffer[SST_6] = Variable(RcvBuff[21],RcvBuff[22],RcvBuff[23]);
								StsBuffer[SST_7] = Variable(RcvBuff[25],RcvBuff[26],RcvBuff[27]);


                                                                Query = 2;

                        	                        break;

	                               	                case FIR_REQ:
				                                StsBuffer[FIR_1]  = 0x20;       //space character
        				                        StsBuffer[FIR_2]  = 0x20;
                      					        StsBuffer[FIR_3]  = 0x20;
				                                StsBuffer[FIR_4]  = 0x20;
                                				StsBuffer[FIR_5]  = 0x20;
                                				StsBuffer[FIR_6]  = 0x20;
                                				StsBuffer[FIR_7]  = 0x20;
                                				StsBuffer[FIR_8]  = 0x20;
                                				StsBuffer[EXFIR_9]  = 0x20;
                                				StsBuffer[EXFIR_10] = 0x20;
                                				StsBuffer[EXFIR_11] = 0x20;
                                				StsBuffer[EXFIR_12] = 0x20;
                                				StsBuffer[EXFIR_13] = 0x20;
                                				StsBuffer[EXFIR_14] = 0x20;
                                				StsBuffer[EXFIR_15] = 0x20;
                                				StsBuffer[EXFIR_16] = 0x20;

								for( loop = 0; loop < RcvLength; loop++ )
								{
									if( loop < 8 )
										StsBuffer[FIR_1+loop] = RcvBuff[loop];
									else if( (loop > 7) && (loop < 16) )
										StsBuffer[EXFIR_9+loop-8] = RcvBuff[loop];
								}

								/*
								StsBuffer[FIR_1] = RcvBuff[0];
								StsBuffer[FIR_2] = RcvBuff[1];
								StsBuffer[FIR_3] = RcvBuff[2];
								StsBuffer[FIR_4] = RcvBuff[3];
								StsBuffer[FIR_5] = RcvBuff[4];
								StsBuffer[FIR_6] = RcvBuff[5];
								StsBuffer[FIR_7] = RcvBuff[6];
								StsBuffer[FIR_8] = RcvBuff[7];
								*/
                                                                //printf("OK_FIR\n");
                                                                StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

                                                                Query = 2;

                                        	        break;

	                                                case CLK_REQ:
                                                                if( (RcvBuff[0] != '$') || (RcvBuff[3] != ':') )
                                                                {
                                                                        Query = 4;
                                                                        break;
                                                                }

								ParametersErrCounter[CLK_REQ] = 0;
								StsBuffer[CLK_1] = (RcvBuff[1]-48)*10 + (RcvBuff[2]-48);
								StsBuffer[CLK_2] = (RcvBuff[4]-48)*10 + (RcvBuff[5]-48);

                                                                //printf("OK_CLK\n");
                                                                StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

                                                                Query = 2;

        	                                        break;

                	                                case DAT_REQ:
                                                                if( (RcvBuff[0] != '$') )
                                                                {
                                                                        Query = 4;
                                                                        break;
                                                                }

								ParametersErrCounter[DAT_REQ] = 0;
                                                                StsBuffer[DAT_1] = (RcvBuff[1]-48)*10 + (RcvBuff[2]-48);
                                                                StsBuffer[DAT_2] = (RcvBuff[3]-48)*10 + (RcvBuff[4]-48);
								StsBuffer[DAT_3] = (RcvBuff[5]-48)*10 + (RcvBuff[6]-48);

                                                                //printf("OK_DAT\n");
                                                                StsBuffer[COMSTATUS] = COM_ESTABLISHED;
                                                                ComStatusBackCounter = COMSTATUSTIMEOUTSN;

                                                                Query = 2;

                        	                        break;

							default:
							break;
						}
					}
					else
						Query = 4;
                		}
				else if( TimeoutCntr == 0 )
				{
					//Timeout - Clear variables
					Query = 3;
				}
			break;
			case 2:	//OK
                        	if( ++ParCntr > (PARAMETERS_MAX-1) )
                        		ParCntr = 0;

				ClearBuffer(RcvBuff,RcvLength);
				Query = 0;
			break;
			case 3:	//TIMEOUT

				VariableClear(ParCntr);

                                if( ++ParCntr > (PARAMETERS_MAX-1) )
                                        ParCntr = 0;

                                ClearBuffer(RcvBuff,MAXSIZE);
                                Query = 0;

				//printf("TIMEOUT\n");
			break;
			case 4: //FRAME ERR

				VariableClear(ParCntr);

                                if( ++ParCntr > (PARAMETERS_MAX-1) )
                                        ParCntr = 0;

                                ClearBuffer(RcvBuff,MAXSIZE);
                                Query = 0;

				//printf("FRAME ERROR\n");
			break;
			default:
			break;
		}
		TransferVariableAndDynamic();
		ControlFunction();
	}

    	tcsetattr(fd, TCSANOW, &oldtio);
    	close(fd);
	return 0;
}

void TransferVariableAndDynamic(void)
{
	unsigned short i = 0;


	for( i = 0;i < (SHAREDMEM_ADDR_COUNT+1);i++ )
	{
		if( (i >= CONTROLSTARTADDR) && (i <= CONTROLSTOPADDR) )		//Dynamic to Variable
		{
			StsBuffer[i] = *(DynamicAddr+SHAREDMEM_START_ADDR + i);
		}
		else					//Variable to Dynamic
		{
			*(DynamicAddr+SHAREDMEM_START_ADDR + i) = StsBuffer[i];
		}
	}

}

void ControlFunction(void)
{
	unsigned short i = 0;

	if( CntrlFLAG == UART_CNTRL_AND_PERIODIC_READY )
	{

		if( StsBuffer[CONTROLRESETSTS] == UART_RESET_COMMAND )
		{
//			printf("CONTROLRESETSTS:%d\n",StsBuffer[CONTROLRESETSTS]);
			CntrlFLAG  = UART_CNTRL_WILL_SEND;
			CntrlParNo = UARTBUFF_CONTOLRESETSTS;
			StsBuffer[CONTROLRESETSTS] = 0;
			*(DynamicAddr+CONTROLRESETSTS) = StsBuffer[CONTROLRESETSTS];
			CntrlCounter = 0;
		}
	        else if( StsBuffer[CONTROLCLEARALARMS] == UART_CLRALR_COMMAND )
        	{
//                	printf("CONTROLCLEARALARMS:%d\n",StsBuffer[CONTROLCLEARALARMS]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLCLEARALARMS;
			StsBuffer[CONTROLCLEARALARMS] = 0;
	                *(DynamicAddr+CONTROLCLEARALARMS) = StsBuffer[CONTROLCLEARALARMS];
			CntrlCounter = 0;
	        }
	        else if( (StsBuffer[CONTROLLOGIN] != UART_LOGOUT_COMMAND) && (StsBuffer[CONTROLLOGIN] != 0) )
	        {
//	                printf("CONTROLLOGIN:%d\n",StsBuffer[CONTROLLOGIN]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLLOGIN;
			LoginPassword = StsBuffer[CONTROLLOGIN];
			StsBuffer[CONTROLLOGIN] = 0;
	                *(DynamicAddr+CONTROLLOGIN) = StsBuffer[CONTROLLOGIN];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLLOGIN] == UART_LOGOUT_COMMAND )
	        {
//	                printf("CONTROLLOGIN:%d\n",StsBuffer[CONTROLLOGIN]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLLOGOUT;
			StsBuffer[CONTROLLOGIN] = 0;
	                *(DynamicAddr+CONTROLLOGIN) = StsBuffer[CONTROLLOGIN];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLSHUTDOWN] == UART_SHUTDOWN_COMMAND )
	        {
//	                printf("CONTROLSHUTDOWN:%d\n",StsBuffer[CONTROLSHUTDOWN]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLSHUTDOWN;
			StsBuffer[CONTROLSHUTDOWN] = 0;
	                *(DynamicAddr+CONTROLSHUTDOWN) = StsBuffer[CONTROLSHUTDOWN];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLRESETSHUTDOWN] == UART_RESETSHUTDOWN_COMMAND )
	        {
//	                printf("CONTROLRESETSHUTDOWN:%d\n",StsBuffer[CONTROLRESETSHUTDOWN]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLRESETSHUTDOWN;
			StsBuffer[CONTROLRESETSHUTDOWN] = 0;
	                *(DynamicAddr+CONTROLRESETSHUTDOWN) = StsBuffer[CONTROLRESETSHUTDOWN];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLMANUALXFER] == UART_TRANSFER_SOURCE_1_COMMAND )
	        {
//	                printf("CONTROLMANUALXFER:%d\n",StsBuffer[CONTROLMANUALXFER]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_TRANSFER_SOURCE_1;
			StsBuffer[CONTROLMANUALXFER] = 0;
	                *(DynamicAddr+CONTROLMANUALXFER) = StsBuffer[CONTROLMANUALXFER];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLMANUALXFER] == UART_TRANSFER_SOURCE_2_COMMAND )
	        {
//	                printf("CONTROLMANUALXFER:%d\n",StsBuffer[CONTROLMANUALXFER]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_TRANSFER_SOURCE_2;
			StsBuffer[CONTROLMANUALXFER] = 0;
	                *(DynamicAddr+CONTROLMANUALXFER) = StsBuffer[CONTROLMANUALXFER];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLCANCELMANUALXFER] == UART_TRANSFER_CANCEL_COMMAND )
	        {
//	                printf("CONTROLCANCELMANUALXFER:%d\n",StsBuffer[CONTROLCANCELMANUALXFER]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLCANCELMANUALXFER;
			StsBuffer[CONTROLCANCELMANUALXFER] = 0;
	                *(DynamicAddr+CONTROLCANCELMANUALXFER) = StsBuffer[CONTROLCANCELMANUALXFER];
			CntrlCounter = 0;
	        }
	        else if( StsBuffer[CONTROLPERFORMXFERTEST] == UART_PERFORM_XFER_TEST_COMMAND )
	        {
//	                printf("CONTROLPERFORMXFERTEST:%d\n",StsBuffer[CONTROLPERFORMXFERTEST]);
	                CntrlFLAG  = UART_CNTRL_WILL_SEND;
	                CntrlParNo = UARTBUFF_CONTROLPERFORMXFERTEST;
			StsBuffer[CONTROLPERFORMXFERTEST] = 0;
	                *(DynamicAddr+CONTROLPERFORMXFERTEST) = StsBuffer[CONTROLPERFORMXFERTEST];
			CntrlCounter = 0;
	        }
                else if( StsBuffer[CONTROLSQLUPDATEFROMWEBSERVER] == SQLITE_UPDATE_FROM_WEBSERVER )
                {
			SqliteUpdateFromWebServerFLAG = 1;
//                        printf("CONTROLSQLUPDATEFROMWEBSERVER:%d\n",StsBuffer[CONTROLSQLUPDATEFROMWEBSERVER]);
                        StsBuffer[CONTROLSQLUPDATEFROMWEBSERVER] = 0;
                        *(DynamicAddr+CONTROLSQLUPDATEFROMWEBSERVER) = StsBuffer[CONTROLSQLUPDATEFROMWEBSERVER];
                        //CntrlCounter = 0;
                }

	}
}

void VariableClear(unsigned short query)
{
	if( ++ParametersErrCounter[query] > ERR_COUNT)
	{
		ParametersErrCounter[query] = 0;
		switch(query)
		{
			case SAS_REQ:
                        	StsBuffer[SAS_1] = 0;
                                StsBuffer[SAS_2] = 0;
                                StsBuffer[SAS_3] = 0;
				StsBuffer[SAS_4] = 0;
				StsBuffer[SAS_5] = 0;

                                StsBuffer[SAS_1_0] = 0;
                                StsBuffer[SAS_1_1] = 0;
                                StsBuffer[SAS_1_2] = 0;
                                StsBuffer[SAS_1_3] = 0;
                                StsBuffer[SAS_1_4] = 0;
                                StsBuffer[SAS_1_5] = 0;
                                StsBuffer[SAS_1_6] = 0;
                                StsBuffer[SAS_1_7] = 0;
                                StsBuffer[SAS_2_0] = 0;
                                StsBuffer[SAS_2_1] = 0;
                                StsBuffer[SAS_2_2] = 0;
                                StsBuffer[SAS_2_3] = 0;
                                StsBuffer[SAS_2_4] = 0;
                                StsBuffer[SAS_2_5] = 0;
                                StsBuffer[SAS_2_6] = 0;
                                StsBuffer[SAS_2_7] = 0;
                                StsBuffer[SAS_3_0] = 0;
                                StsBuffer[SAS_3_1] = 0;
                                StsBuffer[SAS_3_2] = 0;
                                StsBuffer[SAS_3_3] = 0;
                                StsBuffer[SAS_3_4] = 0;
                                StsBuffer[SAS_3_5] = 0;
                                StsBuffer[SAS_3_6] = 0;
                                StsBuffer[SAS_3_7] = 0;
                                StsBuffer[SAS_4_0] = 0;
                                StsBuffer[SAS_4_1] = 0;
                                StsBuffer[SAS_4_2] = 0;
                                StsBuffer[SAS_4_3] = 0;
                                StsBuffer[SAS_4_4] = 0;
                                StsBuffer[SAS_4_5] = 0;
                                StsBuffer[SAS_4_6] = 0;
                                StsBuffer[SAS_4_7] = 0;
                                StsBuffer[SAS_5_0] = 0;
                                StsBuffer[SAS_5_1] = 0;
                                StsBuffer[SAS_5_2] = 0;
                                StsBuffer[SAS_5_3] = 0;
                                StsBuffer[SAS_5_4] = 0;
                                StsBuffer[SAS_5_5] = 0;
                                StsBuffer[SAS_5_6] = 0;
                                StsBuffer[SAS_5_7] = 0;
			break;
                        case OPL_REQ:
                                StsBuffer[OPL_1] = 0;
                                StsBuffer[OPL_2] = 0;
                                StsBuffer[OPL_3] = 0;
                                StsBuffer[OPL_4] = 0;
                                StsBuffer[OPL_5] = 0;
                                StsBuffer[OPL_6] = 0;
                                StsBuffer[OPL_7] = 0;
                                StsBuffer[OPL_8] = 0;
                        break;
                        case SRV_REQ:
                                StsBuffer[SRV_1] = 0;
                                StsBuffer[SRV_2] = 0;
                                StsBuffer[SRV_3] = 0;
                                StsBuffer[SRV_4] = 0;
                                StsBuffer[SRV_5] = 0;
                                StsBuffer[SRV_6] = 0;
                                StsBuffer[SRV_7] = 0;
                                StsBuffer[SRV_8] = 0;
                        break;
                        case SST_REQ:
                                StsBuffer[SST_1] = 0;
                                StsBuffer[SST_2] = 0;
                                StsBuffer[SST_3] = 0;
                                StsBuffer[SST_4] = 0;
                                StsBuffer[SST_5] = 0;
                                StsBuffer[SST_6] = 0;
                                StsBuffer[SST_7] = 0;
                        break;
                        case FIR_REQ:
				StsBuffer[FIR_1]  = 0x20;	//space character
				StsBuffer[FIR_2]  = 0x20;
				StsBuffer[FIR_3]  = 0x20;
                                StsBuffer[FIR_4]  = 0x20;
                                StsBuffer[FIR_5]  = 0x20;
                                StsBuffer[FIR_6]  = 0x20;
                                StsBuffer[FIR_7]  = 0x20;
                                StsBuffer[FIR_8]  = 0x20;
                                StsBuffer[EXFIR_9]  = 0x20;
                                StsBuffer[EXFIR_10] = 0x20;
                                StsBuffer[EXFIR_11] = 0x20;
                                StsBuffer[EXFIR_12] = 0x20;
                                StsBuffer[EXFIR_13] = 0x20;
                                StsBuffer[EXFIR_14] = 0x20;
                                StsBuffer[EXFIR_15] = 0x20;
                                StsBuffer[EXFIR_16] = 0x20;

                        break;
                        case CLK_REQ:
                                StsBuffer[CLK_1] = 0;
                                StsBuffer[CLK_2] = 0;
                        break;
                        case DAT_REQ:
                                StsBuffer[DAT_1] = 0;
                                StsBuffer[DAT_2] = 0;
                                StsBuffer[DAT_3] = 0;
                        break;

			default:
			break;
		}

	}
}
