#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/ipc.h>                    //Shared memory
#include <sys/shm.h>                    //Shared memory

#define SHAREDMEM_ADDR  				0x1000
#define SHAREDMEM_SIZE  				400
		
#define UARTPROCESS_OK          		1
#define UARTPROCESS_FAULT       		0
		
#define COM_NEVERCONNECTED      		1
#define COM_ESTABLISHED         		2
#define COM_LOST                		3
		
#define ON_S1							0
#define ON_S2							1
		
#define S1_OK							0
#define S1_BAD							1
#define S2_OK							0
#define S2_BAD							1
#define ALTERNATE_OK					2
#define ALTERNATE_LOST					1

/****************  home/pi/uart_sts.c (STS Communication) -> Agent.c  *******************/
#define SAS_1          					0
#define SAS_2           				1
#define SAS_3           				2
#define SAS_4           				3
#define SAS_5           				4
#define SAS_6           				5
#define OPL_1           				6
#define OPL_2           				7
#define OPL_3           				8
#define OPL_4           				9
#define OPL_5           				10
#define OPL_6           				11
#define OPL_7           				12
#define OPL_8           				13
#define SRV_1           				14
#define SRV_2           				15
#define SRV_3           				16
#define SRV_4           				17
#define SRV_5           				18
#define SRV_6           				19
#define SRV_7           				20
#define SRV_8           				21
#define SST_1           				22
#define SST_2           				23
#define SST_3           				24
#define SST_4           				25
#define SST_5           				26
#define SST_6           				27
#define SST_7           				28
#define CLK_1           				29
#define CLK_2           				30
#define DAT_1           				31
#define DAT_2           				32
#define DAT_3           				33
#define FIR_1           				34
#define FIR_2           				35
#define FIR_3           				36
#define FIR_4           				37
#define FIR_5           				38
#define FIR_6           				39
#define FIR_7           				40
#define FIR_8							41
#define SAS_1_0         				42
#define SAS_1_1         				43
#define SAS_1_2         				44
#define SAS_1_3         				45
#define SAS_1_4         				46
#define SAS_1_5         				47
#define SAS_1_6         				48
#define SAS_1_7         				49
#define SAS_2_0         				50
#define SAS_2_1         				51
#define SAS_2_2         				52
#define SAS_2_3         				53
#define SAS_2_4         				54
#define SAS_2_5         				55
#define SAS_2_6         				56
#define SAS_2_7         				57
#define SAS_3_0         				58
#define SAS_3_1         				59
#define SAS_3_2         				60
#define SAS_3_3         				61
#define SAS_3_4         				62
#define SAS_3_5         				63
#define SAS_3_6         				64
#define SAS_3_7         				65
#define SAS_4_0         				66
#define SAS_4_1         				67
#define SAS_4_2         				68
#define SAS_4_3         				69
#define SAS_4_4         				70
#define SAS_4_5         				71
#define SAS_4_6         				72
#define SAS_4_7         				73
#define SAS_5_0         				74
#define SAS_5_1         				75
#define SAS_5_2         				76
#define SAS_5_3         				77
#define SAS_5_4         				78
#define SAS_5_5         				79
#define SAS_5_6         				80
#define SAS_5_7         				81
/****************  home/pi/uart_sts.c (sqlite3) -> Agent.c  *******************/
#define DUMMY1                  		82
#define NOMINALVOLT             		83
#define NOMINALFREQ             		84
#define NOMINALCURR             		85
#define PHASECOUNT              		86
#define POLECOUNT               		87
#define COMSTATUS               		88
#define OUTVOLTAGE              		89			//tek fazda kullaniliyor
#define OUTFREQ                 		90
#define MODELNAME_1             		91
#define MODELNAME_2             		92
#define MODELNAME_3             		93
#define MODELNAME_4             		94
#define MODELNAME_5             		95
#define MODELNAME_6             		96
#define MODELNAME_7             		97
#define MODELNAME_8             		98
#define MODELNAME_9             		99
#define MODELNAME_10            		100
#define MODELNAME_11            		101
#define MODELNAME_12            		102
#define MODELNAME_13            		103
#define MODELNAME_14            		104
#define MODELNAME_15            		105
#define MODELNAME_16            		106
/****************  /usr/share/snmp/STS/Agent.c -> uart_sts.c (STS Communication)  *******************/
#define CONTROLRESETSTS         		107
#define CONTROLCLEARALARMS      		108
#define CONTROLLOGIN            		109
#define CONTROLSHUTDOWN         		110
#define CONTROLRESETSHUTDOWN    		111
#define CONTROLMANUALXFER       		112
#define CONTROLCANCELMANUALXFER 		113
#define CONTROLPERFORMXFERTEST  		114
#define CONTROLSQLUPDATEFROMWEBSERVER 	115
#define CONTROLWEBSERVERSTARTED 116 //11.01.2021 tarihinde eklendi



/*********************************4 kutup icin eklenenler********************************************/
#define OUTVOLTAGE_L1					118 //116
#define OUTVOLTAGE_L2					119 //117
#define OUTVOLTAGE_L3					120 //118


/* BOSLUK VAR, CONTROL ICIN BIRAKILDI, KULLANILABILIR */

#define EXFIR_9                 		130
#define EXFIR_10                		131
#define EXFIR_11                		132
#define EXFIR_12                		133
#define EXFIR_13                		134
#define EXFIR_14                		135
#define EXFIR_15                		136
#define EXFIR_16                		137


#define SHAREDMEM_START_ADDR    		0	
#define SHAREDMEM_ADDR_COUNT    		137

#define CONTROLSTARTADDR        		107
#define CONTROLSTOPADDR         		116





unsigned short StsBuffer[SHAREDMEM_ADDR_COUNT+1];
unsigned short *DynamicAddr;
int ShmID;

void active_shared(void)
{
    //Shared Memory i acar.
    if ((ShmID = shmget(SHAREDMEM_ADDR,SHAREDMEM_SIZE,IPC_CREAT|0666)) < 0)
    {
            perror("shmget");
    }
    if ((DynamicAddr = (unsigned short *)shmat(ShmID, NULL, 0)) == (void *) -1)
    {
            perror("shmat");
    }
}

#define OIDCOUNT                57 //47 tek faz icindi
#define SENDOIDCOUNT	10//     	9  //	8



//asagidaki normal ve alarm durumları degistirildi. satir.if( (i>7) && (i<24) ) da dogrusu yapili. bu nedenden oturu normal(1) alarm durumlari (2) oldu yine de incelenmeli
const unsigned char *myOID[OIDCOUNT] = {

/*00*/  ".1.3.6.1.4.1.54358.1.1.5.1.1.0",        	//stsidentFirware	     					FIR_1 & FIR_2 & FIR_3 & ... & FIR_8
/*01*/  ".1.3.6.1.4.1.54358.1.1.5.1.2.0",          	//stsidentModelNumber						MODEL NAME : 8 adet			(sqlite3)
/*02*/  ".1.3.6.1.4.1.54358.1.1.5.1.3.0",          	//stsidentNominalVoltage        			NOMINALVOLT     			(sqlite3)
/*03*/  ".1.3.6.1.4.1.54358.1.1.5.1.4.0",          	//stsidentNominalFrequency      			NOMINALFREQ     			(sqlite3)
/*04*/  ".1.3.6.1.4.1.54358.1.1.5.1.5.0",          	//stsidentDeviceCurrentRating   			NOMINALCURR     			(sqlite3)
/*05*/  ".1.3.6.1.4.1.54358.1.1.5.1.6.0",          	//stsidentDevicePhases          			PHASECOUNT      			(sqlite3)
/*06*/  ".1.3.6.1.4.1.54358.1.1.5.1.7.0",          	//stsidentDevicePole            			POLECOUNT       			(sqlite3)
/*07*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.1.0",      	//stsCommStatus                 			COMSTATUS					stsNeverConnected(1), stsCommEstablished(2), stsCommLost(3)
/*08*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.2.0",        	//stsStatusSelectedSource					SAS_5_1						source1(1) source2(2)
/*09*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.3.0",        	//stsStatusAlternateState       			SAS_5_1|SAS_3_0|SAS_3_1		stsAlternateLost(1) stsAlternateReady(2)
/*10*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.4.0",        	//stsStatusPSP1								SAS_4_0						stsPowerSupplyFailure(1) stsPowerSupplyOK(2)
/*11*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.5.0",        	//stsStatusPSP2								SAS_4_1						stsPowerSupplyFailure(1) stsPowerSupplyOK(2)
/*12*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.6.0",        	//stsStatusSourceS1							SAS_3_0						fail(1) ok(2)
/*13*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.7.0",        	//stsStatusSourceS2							SAS_3_1						fail(1) ok(2)
/*14*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.8.0",        	//stsStatusPhaseSyncStatus					SAS_3_2						inSync(1) outofSync(2)
/*15*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.9.0",        	//stsStatusVoltageOutStatus					SAS_3_4|SAS_3_5|SAS_4_7		fail(1) ok(2)
/*16*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.10.0",       	//stsStatusOverloadStatus					SAS_3_3						overload(1) ok(2)
/*17*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.11.0",       	//stsStatusOvertemperatureStatus			SAS_3_6						OverTemperature(1) ok(2)
/*18*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.12.0",       	//stsStatusManualTransferStatus 			SAS_4_3|SAS_4_4|SAS_4_5|SAS_4_6 ManualTransfer(1) normal(2)
/*19*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.13.0",       	//stsStatusPreferedSource					SAS_5_0						Source1(1) Sounce2(2)
/*20*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.14.0",       	//stsStatusXFERtestStatus					SAS_3_7						Performing(1) normal(2)
/*21*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.15.0",       	//stsStatusServiceLoginState				SAS_5_2						Performing(1) normal(2)
/*22*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.16.0",       	//stsStatusUserLoginState					SAS_5_4						Performing(1) normal(2)
/*23*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.17.0",       	//stsStatusBackFeedState					SAS_5_5|SAS_5_6				BackfeedProtect(1) normal(2)
/*24*/	".1.3.6.1.4.1.54358.1.1.5.4.1.27.0",		//stsStatusStsTime							CLK_1:CLK_2
/*25*/	".1.3.6.1.4.1.54358.1.1.5.4.1.28.0",		//stsStatusStsDate							DAT_1.DAT_2.DAT_3


/*26*/	".1.3.6.1.4.1.54358.1.1.5.4.2.1.0",			//stsInputVoltageS1L1						SRV_1
/*27*/	".1.3.6.1.4.1.54358.1.1.5.4.2.2.0",			//stsInputVoltageS1L2						SRV_2
/*28*/	".1.3.6.1.4.1.54358.1.1.5.4.2.3.0",			//stsInputVoltageS1L3						SRV_3
/*29*/	".1.3.6.1.4.1.54358.1.1.5.4.2.4.0",			//stsInputVoltageS2L1						SRV_4
/*30*/	".1.3.6.1.4.1.54358.1.1.5.4.2.5.0",			//stsInputVoltageS2L2						SRV_5
/*31*/	".1.3.6.1.4.1.54358.1.1.5.4.2.6.0",			//stsInputVoltageS2L3						SRV_6
/*32*/	".1.3.6.1.4.1.54358.1.1.5.4.2.7.0",			//stsInputFreqS1							SRV_7
/*33*/	".1.3.6.1.4.1.54358.1.1.5.4.2.8.0",			//stsInputFreqS2							SRV_8
/*34*/  ".1.3.6.1.4.1.54358.1.1.5.4.2.9.0",        	//stsInputSynchronAngle						OPL_8
/*35*/  ".1.3.6.1.4.1.54358.1.1.5.4.2.10.0",       	//stsInputPSP1Voltage						SST_6
/*36*/  ".1.3.6.1.4.1.54358.1.1.5.4.2.11.0",        //stsInputPSP2Voltage						SST_7
/*37*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.1.0",        	//stsOutputVoltageL1						OUTVOLTAGE_L1
/*38*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.2.0",        	//stsOutputVoltageL2						OUTVOLTAGE_L2
/*39*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.3.0",        	//stsOutputVoltageL3						OUTVOLTAGE_L3
/*40*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.4.0",        	//stsOutputFrequency            			OUTFREQ
/*41*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.5.0",        	//stsOutputLoadPercentageL1					OPL_1
/*42*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.6.0",        	//stsOutputLoadPercentageL2					OPL_2
/*43*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.7.0",        	//stsOutputLoadPercentageL3					OPL_3
/*44*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.8.0",        	//stsOutputCurrentL1						OPL_4
/*45*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.9.0",        	//stsOutputCurrentL2						OPL_5
/*46*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.10.0",       	//stsOutputCurrentL3						OPL_6
/*47*/  ".1.3.6.1.4.1.54358.1.1.5.4.3.11.0",        //stsOutputTempareture						OPL_7
	
/*48*/	".1.3.6.1.4.1.54358.1.1.5.4.1.18.0",		//stsStatus1PhaseNonSynchronInhibit			//SAS_3_4
/*49*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.19.0",       	//stsStatus1PhaseTransferInhibit			//SAS_3_5
/*50*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.20.0",		//stsStatus1PhaseOutputSwitchStatus			//SAS_4_7
/*51*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.21.0",		//stsStatus1PhaseManXFERtoS1				//SAS_4_3
/*52*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.22.0",       	//stsStatus1PhaseManXFERtoS2				//SAS_4_4
/*53*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.23.0",       	//stsStatus1PhaseMaintananceBypassS1		//SAS_4_5
/*54*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.24.0",       	//stsStatus1PhaseMaintananceBypassS2		//SAS_4_6
/*55*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.25.0",       	//stsStatus1PhaseOutputSCRAlternansStatus	//SAS_4_2
/*56*/  ".1.3.6.1.4.1.54358.1.1.5.4.1.26.0"        	//stsStatus1PhaseSoundStatus				//SAS_5_3


};

const unsigned char *mySendOID[SENDOIDCOUNT] = {
/*0*/	".1.3.6.1.4.1.54358.1.1.5.2.1.0",			//stsControlResetSTS						CONTROLRESETSTS				none(1)  reset(2)	(RESET-> EKLECEK)
/*1*/   ".1.3.6.1.4.1.54358.1.1.5.2.2.0",			//stsControlClearAllAlarms					CONTROLCLEARALARMS			none(1)  clear(2)	(CLRALR->EKLENECEK)
/*2*/	".1.3.6.1.4.1.54358.1.1.5.2.3.0",			//stsControlLoginState						CONTROLLOGIN				login(sifre) logout(2) 	(PXXXX - OUT)
/*3*/	".1.3.6.1.4.1.54358.1.1.5.2.4.0",			//stsControlShutdown						CONTOLSHUTDOWN				shutdown(1) 	    	(INH)
/*4*/	".1.3.6.1.4.1.54358.1.1.5.2.5.0",			//stsControlResetShutdown					CONTROLRESETSHUTDOWN    	resetshutdown(1)    	(IHR)
/*5*/	".1.3.6.1.4.1.54358.1.1.5.2.6.0",			//stsControlManualXFER						CONTROLMANUALXFER			Source1(1) Source2(2)	(XF1 - XF2)
/*6*/	".1.3.6.1.4.1.54358.1.1.5.2.7.0",			//stsControlCancelManualXFER				CONTROLCANCELMANUALXFER		Always(1)		(CXF)
/*7*/	".1.3.6.1.4.1.54358.1.1.5.2.8.0",			//stsControlPerformXFERTest					CONTROLPERFORMXFERTEST		Always(1)		(TST)
/*8*/   ".1.3.6.1.4.1.54358.1.1.5.2.50.0",           //Kendim koydum (sqlite update from web server)
/*9*/   ".1.3.6.1.4.1.54358.1.1.5.2.51.0"           //Kendim koydum (web server started and continue)
};


unsigned char myOID_StsBuff[OIDCOUNT] = {
/*00*/  0xff,										//FIR_1 & FIR_2 & FIR_3 & ... & FIR_8
/*01*/  0xf7,										//MODEL NAME : 8 adet
/*02*/  NOMINALVOLT,
/*03*/  NOMINALFREQ,
/*04*/  NOMINALCURR,
/*05*/  PHASECOUNT,
/*06*/  POLECOUNT,
/*07*/  COMSTATUS,									//COMSTATUS
/*08*/  SAS_5_1,
/*09*/  0xfd,										//SAS_5_1|SAS_3_0|SAS_3_1
/*10*/  SAS_4_0,
/*11*/  SAS_4_1,
/*12*/  SAS_3_0,
/*13*/  SAS_3_1,
/*14*/  SAS_3_2,
/*15*/  0xfc,										//SAS_3_4|SAS_3_5|SAS_4_7
/*16*/  SAS_3_3,
/*17*/  SAS_3_6,
/*18*/  0xfb,										//SAS_4_3|SAS_4_4|SAS_4_5|SAS_4_6
/*19*/  SAS_5_0,
/*20*/  SAS_3_7,
/*21*/  SAS_5_2,
/*22*/  SAS_5_4,
/*23*/  0xfa,										//SAS_5_5|SAS_5_6
/*24*/  0xf9,										//CLK_1:CLK_2
/*25*/  0xf8,										//DAT_1.DAT_2.DAT_3

/*26*/  SRV_1,
/*27*/  SRV_2,
/*28*/  SRV_3,
/*29*/  SRV_4,
/*30*/  SRV_5,
/*31*/  SRV_6,
/*32*/  SRV_7,
/*33*/  SRV_8,
/*34*/  OPL_8,
/*35*/  SST_6,
/*36*/  SST_7,
/*37*/	OUTVOLTAGE_L1,
/*38*/	OUTVOLTAGE_L2,
/*39*/	OUTVOLTAGE_L3,
/*40*/	OUTFREQ,
/*41*/  OPL_1,
/*42*/  OPL_2,
/*43*/  OPL_3,
/*44*/  OPL_4,
/*45*/  OPL_5,
/*46*/  OPL_6,
/*47*/  OPL_7,

/*48*/	SAS_3_4,
/*49*/  SAS_3_5,
/*50*/  SAS_4_7,
/*51*/  SAS_4_3,
/*52*/  SAS_4_4,
/*53*/  SAS_4_5,
/*54*/  SAS_4_6,
/*55*/  SAS_4_2,
/*56*/  SAS_5_3




};


void DynamicToVariable(void)
{
        unsigned short i = 0;

        for( i = 0;i < (SHAREDMEM_ADDR_COUNT+1);i++ )
        {
                StsBuffer[i] = *(DynamicAddr+SHAREDMEM_START_ADDR + i);
        }
        if( StsBuffer[SAS_5_1] == ON_S1 )
        {
        	StsBuffer[OUTVOLTAGE_L1] = StsBuffer[SRV_1];
        	StsBuffer[OUTVOLTAGE_L2] = StsBuffer[SRV_2];
        	StsBuffer[OUTVOLTAGE_L3] = StsBuffer[SRV_3];
			StsBuffer[OUTFREQ] = StsBuffer[SRV_7];
        }
        else if( StsBuffer[SAS_5_1] == ON_S2 )
        {
        	StsBuffer[OUTVOLTAGE_L1] = StsBuffer[SRV_4];
        	StsBuffer[OUTVOLTAGE_L2] = StsBuffer[SRV_5];
        	StsBuffer[OUTVOLTAGE_L3] = StsBuffer[SRV_6];
            StsBuffer[OUTFREQ] = StsBuffer[SRV_8];
        }
/*	Emin degilim o yuzden kapattim.
	if( (StsBuffer[SAS_3_4] | StsBuffer[SAS_3_5] | StsBuffer[SAS_4_7]) == 1 )	//Output Voltage Status
	{
		StsBuffer[OUTVOLTAGE] = 0;
                StsBuffer[OUTFREQ] = 0;
	}
*/
}


void VariableToDynamic(void)
{
    *(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLRESETSTS)         = StsBuffer[CONTROLRESETSTS];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLCLEARALARMS)      = StsBuffer[CONTROLCLEARALARMS];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLLOGIN)            = StsBuffer[CONTROLLOGIN];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLSHUTDOWN)         = StsBuffer[CONTROLSHUTDOWN];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLRESETSHUTDOWN)    = StsBuffer[CONTROLRESETSHUTDOWN];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLMANUALXFER)       = StsBuffer[CONTROLMANUALXFER];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLCANCELMANUALXFER) = StsBuffer[CONTROLCANCELMANUALXFER];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLPERFORMXFERTEST)  = StsBuffer[CONTROLPERFORMXFERTEST];
	*(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLSQLUPDATEFROMWEBSERVER)  = StsBuffer[CONTROLSQLUPDATEFROMWEBSERVER];
        *(DynamicAddr+SHAREDMEM_START_ADDR + CONTROLWEBSERVERSTARTED)  = StsBuffer[CONTROLWEBSERVERSTARTED];
}

void ClearBufferAndDynamic(void)
{
        unsigned short i = 0;

        for( i = 0;i < (SHAREDMEM_ADDR_COUNT+1);i++ )
        {
                *(DynamicAddr+SHAREDMEM_START_ADDR + i) = StsBuffer[i] = 0;
        }
}


int main ( int argc, char **argv )
{

	const char *rcvOID = "1.3.6.1.4.1.54358";
	int value = 0;
	unsigned short i = 0;
	unsigned short z = 0;
	char FirArray[16];
	char ModelNameArray[16];
	long conv = 0;
	char *ptr;
	unsigned short uartStsProcessStatus = UARTPROCESS_FAULT;
	char dummyArray[8] = { '0','0','0','0','0','0','0','0' };

	active_shared();


   	if(0 == system("pidof -s uart_sts_myos > /dev/null")) 
	{
//		printf("running\n");
		uartStsProcessStatus = UARTPROCESS_OK;
   	}
   	else
   	{
//		printf(" system != 0 \n");
		//Burada degerler sifirlanacak
		uartStsProcessStatus = UARTPROCESS_FAULT;
		ClearBufferAndDynamic();
   	}
	DynamicToVariable();

	if( (strstr( argv[1], "-g") != NULL) && (strstr( argv[2], rcvOID) != NULL) )
	{
		if( (uartStsProcessStatus == UARTPROCESS_FAULT) || (StsBuffer[COMSTATUS] == COM_NEVERCONNECTED) )
		{
			if( (strstr( myOID[0],argv[2]) != NULL) || (strstr( myOID[24],argv[2]) != NULL) || (strstr( myOID[25],argv[2]) != NULL) )
			{
				printf("%s\nstring\n%c\n",argv[2],dummyArray[0]);
			}
                        else if( strstr( myOID[1],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
                        {
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
				{
					for( z = 0;z < 16;z++)
                                                ModelNameArray[z] = (char)StsBuffer[MODELNAME_1+z];
                                        printf("%s\nstring\n%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",argv[2],
                                                                                        ModelNameArray[0],ModelNameArray[1],ModelNameArray[2],
                                                                                        ModelNameArray[3],ModelNameArray[4],ModelNameArray[5],
                                                                                        ModelNameArray[6],ModelNameArray[7],ModelNameArray[8],
                                                                                        ModelNameArray[9],ModelNameArray[10],ModelNameArray[11],
                                                                                        ModelNameArray[12],ModelNameArray[13],ModelNameArray[14],
                                                                                        ModelNameArray[15]  );
				}
				else
					printf("%s\nstring\n%c\n",argv[2],dummyArray[0]);
			}
			else if( strstr( myOID[2],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
			{
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[NOMINALVOLT];

                                printf("%s\ninteger\n%d\n",argv[2],value);		//uart calisiyor ve neverconnected olduysa database verileri
			}
			else if( strstr( myOID[3],argv[2]) != NULL )
                        {
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[NOMINALFREQ];

                                printf("%s\ninteger\n%d\n",argv[2],value);
                        }
			else if( strstr( myOID[4],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
                        {
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[NOMINALCURR];

                                printf("%s\ninteger\n%d\n",argv[2],value);
                        }
			else if( strstr( myOID[5],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
                        {
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[PHASECOUNT];

                                printf("%s\ninteger\n%d\n",argv[2],value);
                        }
			else if( strstr( myOID[6],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
                        {
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[POLECOUNT];

                                printf("%s\ninteger\n%d\n",argv[2],value);
                        }
                        else if( strstr( myOID[7],argv[2]) != NULL )			//uart calisiyor ve neverconnected olduysa database verileri
                        {
                                value = 0;
                                if( uartStsProcessStatus != UARTPROCESS_FAULT )
                                        value = StsBuffer[COMSTATUS];

                                printf("%s\ninteger\n%d\n",argv[2],value);
                        }
			else
			{
				value = 0;
				printf("%s\ninteger\n%d\n",argv[2],value);
			}
			return 0;
		}

		for( i = 0; i < OIDCOUNT; i++ )
		{
			if( strstr( myOID[i],argv[2]) != NULL)
			{
				if( myOID_StsBuff[i] < 0xf0 )
				{
					value = StsBuffer[myOID_StsBuff[i]];

					if( (i>7) && (i<24) )		//Alarm bitlerinin oldugu yerler
                                        {
						if( i == 8 )		//stsStatusSelectedSource - source1(1) source2(2)
						{
	                                                if( value == 1 )
        	                                                value = 2;
                	                                else if( value == 0 )
                        	                                value = 1;

						}
						else if( i == 19 )	//stsStatusPreferedSource - Source1(1) Sounce2(2)
						{
							if( value == 1 )
                                                                value = 2;
                                                        else if( value == 0 )
                                                                value = 1;
						}
						else if( i == 14 )	//stsStatusPhaseSyncStatus - inSync(1) outofSync(2)
						{
							if( value == 1 )
								value = 2;
                                                        else if( value == 0 )
                                                                value = 1;

						}
						else
						{
                                                	if( value == 1 )
                                                        	value = 2;
                                                	else if( value == 0 )
                                                        	value = 1;
						}
                                        }
					if( (i>37) && (i<47) )	//yeni eklenen alarm bitleri
					{
						if( value == 1 )
                                                	value = 2;
                                                else if( value == 0 )
                                                        value = 1;
					}

					printf("%s\ninteger\n%d\n",argv[2],value);
				}
				else if( myOID_StsBuff[i] == 0xff )	//FIR_1 & FIR_2 & FIR_3 & ... & FIR_8
				{
                                        for( z = 0;z < 8;z++)
                                                FirArray[z] = (char)StsBuffer[FIR_1+z];
					for( z = 0;z < 8;z++)
                                                FirArray[z+8] = (char)StsBuffer[EXFIR_9+z];
                                        printf("%s\nstring\n%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",argv[2],FirArray[0],FirArray[1],FirArray[2],
													FirArray[3],FirArray[4],FirArray[5],
													FirArray[6],FirArray[7],FirArray[8],
													FirArray[9],FirArray[10],FirArray[11],
													FirArray[12],FirArray[13],FirArray[14],
                                                                                                        FirArray[15]  );
                                //      printf("%s\nstring\n%c%c%c\n",argv[2],StsBuffer[FIR_1],StsBuffer[FIR_2],StsBuffer[FIR_3]);

				}
                                else if( myOID_StsBuff[i] == 0xfd  )	//SAS_5_1|SAS_3_0|SAS_3_1
                                {
					if( StsBuffer[SAS_5_1] == ON_S1 )
					{
						if( StsBuffer[SAS_3_1] == S2_OK )
							value = ALTERNATE_OK;
						else if( StsBuffer[SAS_3_1] == S2_BAD )
							value = ALTERNATE_LOST;
					}
					else if( StsBuffer[SAS_5_1] == ON_S2 )
					{
						if( StsBuffer[SAS_3_0] == S1_OK )
                                                        value = ALTERNATE_OK;
                                                else if( StsBuffer[SAS_3_0] == S1_BAD )
                                                        value = ALTERNATE_LOST;
					}

					printf("%s\ninteger\n%d\n",argv[2],value);
                                }
                                else if( myOID_StsBuff[i] == 0xfc )	//SAS_3_4|SAS_3_5|SAS_4_7
                                {
					value = StsBuffer[SAS_3_4] | StsBuffer[SAS_3_5] | StsBuffer[SAS_4_7];

                                        if( value == 1 )
                                                value = 2;
                                        else if( value == 0 )
                                                value = 1;

                                        printf("%s\ninteger\n%d\n",argv[2],value);
                                }
                                else if( myOID_StsBuff[i] == 0xfb )	//SAS_4_3|SAS_4_4|SAS_4_5|SAS_4_6
                                {
					value = StsBuffer[SAS_4_3] | StsBuffer[SAS_4_4] | StsBuffer[SAS_4_5] | StsBuffer[SAS_4_6];

                                        if( value == 1 )
                                                value = 2;
                                        else if( value == 0 )
                                                value = 1;

                                        printf("%s\ninteger\n%d\n",argv[2],value);
                                }
                                else if( myOID_StsBuff[i] == 0xfa )	//SAS_5_5|SAS_5_6
                                {
					value = StsBuffer[SAS_5_5] | StsBuffer[SAS_5_6];

                                        if( value == 1 )
                                                value = 2;
                                        else if( value == 0 )
                                                value = 1;

                                        printf("%s\ninteger\n%d\n",argv[2],value);
                                }
                                else if( myOID_StsBuff[i] == 0xf9 )	//CLK_1:CLK_2
                                {
					printf("%s\nstring\n%02d:%02d\n",argv[2],StsBuffer[CLK_1],StsBuffer[CLK_2]);
                                }
                                else if( myOID_StsBuff[i] == 0xf8 )	//DAT_1.DAT_2.DAT_3
                                {
                                        printf("%s\nstring\n%02d.%02d.%02d\n",argv[2],StsBuffer[DAT_1],StsBuffer[DAT_2],StsBuffer[DAT_3]);
                                }
				else if( myOID_StsBuff[i] == 0xf7 )     //MODEL CODE : 8 adet -> MODELNAME_1 - MODELNAME_8
                                {
                                        for( z = 0;z < 16;z++)
                                                ModelNameArray[z] = (char)StsBuffer[MODELNAME_1+z];
                                        //printf("%s\nstring\n%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c%c\n",argv[2],
					//						ModelNameArray[0],ModelNameArray[1],ModelNameArray[2],
                                        //                                                ModelNameArray[3],ModelNameArray[4],ModelNameArray[5],
                                        //                                                ModelNameArray[6],ModelNameArray[7],ModelNameArray[8],
					//						ModelNameArray[9],ModelNameArray[10],ModelNameArray[11],
                                        //                                                ModelNameArray[12],ModelNameArray[13],ModelNameArray[14],
                                        //                                                ModelNameArray[15]  );
					//printf("deneme\n");
					printf("%s\nstring\n%s\n",argv[2],ModelNameArray);

				}


				return 0;
			}
		}


	}
	else if( (strstr( argv[1], "-s") != NULL) && (strstr( argv[2], rcvOID) != NULL) )
	{
//		printf("cevap ne gonderilecek bilmiyorum\n");
                for( i = 0; i < SENDOIDCOUNT; i++ )
                {
                        if( strstr( mySendOID[i],argv[2]) != NULL)
                        {
				if( strstr( argv[3],"integer") != NULL)
				{
//printf("deneme\n");
					conv = strtol(argv[4], &ptr, 10);
                                        //StsBuffer[CONTROLRESETSTS] = *argv[4]; String olsaydi.
                                        StsBuffer[CONTROLRESETSTS+i] = (unsigned short)conv;
                                        VariableToDynamic();
                                        printf("%s\ninteger\n%d\n",argv[2],(StsBuffer[CONTROLRESETSTS+i]));
				}
			 }
		}
	}
	else	//debug icin kullandim.
	{
		printf("debug%s\ninteger\n%d\n",argv[2],(StsBuffer[CONTROLRESETSTS+i]));
	}


        return 0;
}


